

  subroutine DDtrigger_EFT(v0,vesc,jx,mx,Ci,chisq)
    use DirectDetLike
    use DMFormFactor
    implicit none
    real*8, intent(in) :: v0,vesc,jx,mx,Ci(15)
    real*8, intent(out) :: chisq(3)
    real*8 Rpan,Rlux13,Rlux16
 

    DD__coep(:)=Ci(:)
    DD__seebug=.false.
    if (.not. DD__loaded) call loadDirectDet('Formula',v0,vesc)
    if (.not. DirectDetLike__loaded) call Read_DDLikeTable()

    call load_Velocities('Formula',v0,vesc)

    call Predict_R_EFT('PandaX-II',jx,mx,Rpan) 
    call DDexp_chisq('PandaX-II',mx,Rpan,chisq(1))

    call Predict_R_EFT('LUX-2014-2016',jx,mx,Rlux16) 
    call DDexp_chisq('LUX-2014-2016',mx,Rlux16,chisq(2)) 
   
    call Predict_R_EFT('LUX-2013',jx,mx,Rlux13)  
    call DDexp_chisq('LUX-2013',mx,Rlux13,chisq(3)) 
 

    return
  end subroutine DDtrigger_EFT




















subroutine LikeDM_DD_doc(WhatSubroutine)
  implicit none 
  CHARACTER(LEN=*), intent(in) :: WhatSubroutine
  
  if (trim(WhatSubroutine).eq. 'LikeDM-DD') then
    write(*,*) '*******************************************************************************************'
    write(*,*) ''
    write(*,*) '   LikeDM-DD v1 '
    write(*,*) ''
    write(*,*) ' DDtrigger.f90 : introduction message.' 
    write(*,*) ''
    write(*,*) ' DirectDet_likelihood.f90 : likelihood functions' 
    write(*,*) ''
    write(*,*) ' DirectDet_v3.f90 : some subroutines for DD setups.' 
    write(*,*) ''
    write(*,*) ' DMFormFactor.f90 : the gfortran version of "DMFormFactor" code and' 
    write(*,*) '                    the interface of "DirectDM" code.'
    write(*,*) '                    If users want to implement their own models,' 
    write(*,*) '                    please use DirectDM to compute the relationships between coefficents' 
    write(*,*) '                    at the subroutine Calc_total_transition_prob_DirectDM.'
    write(*,*) '' 
    write(*,*) '                    Please check it by '
    write(*,*) ''
    write(*,*) '                      call LikeDM_DD_doc("Calc_total_transition_prob_DirectDM")'
    write(*,*) ''
    write(*,*) '                    DirectDM can be downloaded from'
    write(*,*) '                    https://directdm.github.io/'
    write(*,*) ''
    write(*,*) ' Main_example.f90 : example of useage for gfortran interface. '
    write(*,*) ' pyLikeDM-DD.py   : example of useage for python interface. '
    write(*,*) ''
    write(*,*) ' Auxiliary codes : MathLib.f90 Prior_type.f90 dprand.f90 '
    write(*,*) ''
    write(*,*) '*******************************************************************************************'
    return

   elseif (trim(WhatSubroutine).eq. 'load_Velocities') then 

    write(*,*) ''
    write(*,*) '   LikeDM-DD/help: load_Velocities(Table_or_Formula,v0,vesc) ---> '
    write(*,*) ''
    write(*,*) '   A subroutine to load the default setup of velocity. '
    write(*,*) ''
    write(*,*) '   Table_or_Formula = '
    write(*,*) '       "Table". This option will Call subroutine Load_PreGen_Table for usiing previous generate table.'
    write(*,*) '       "None".  This option will call subroutine integral_f_over_angle to compute DD__f_Distribution(2,:).'
    write(*,*) '       "default" or other characters will use the formula, see Appendix B of 1708.04630'
    write(*,*) '   v0 = local velocity, if no input, the default is 220 km/s'
    write(*,*) '   vesc = escape velocity, if no input, the default is 540 km/s'
    write(*,*) ''

  elseif (trim(WhatSubroutine).eq. 'loadDirectDet') then 

    write(*,*) ''
    write(*,*) '   LikeDM-DD/help: loadDirectDet(Table_or_Formula,v0,vesc) ---> '
    write(*,*) ''
    write(*,*) ''
    write(*,*) '   A subroutine to loaded DirectDet experimental data. The subroutine load_Velocities will be called.'
    write(*,*) ''
    write(*,*) '   Table_or_Formula = '
    write(*,*) '       "Table". This option will Call subroutine Load_PreGen_Table for usiing previous generate table.'
    write(*,*) '       "None".  This option will call subroutine integral_f_over_angle to compute DD__f_Distribution(2,:).'
    write(*,*) '       "default" or other characters will use the formula, see Appendix B of 1708.04630'
    write(*,*) '   v0 = local velocity'
    write(*,*) '   vesc = escape velocity'
    write(*,*) ''

  elseif (trim(WhatSubroutine).eq. 'Calc_dsigmadQ') then 

    write(*,*) ''
    write(*,*) '   LikeDM-DD/help: Calc_dsigmadQ(mx,sigsip,Q,Z,A,mT,v,ans) ---> '
    write(*,*) ''
    write(*,*) '   A subroutine to calculate dsigma/dQ. '
    write(*,*) ''
    write(*,*) '       real*8, intent(in) :: mx,sigsip ! DM mass, spin-independent cross section (pb)'
    write(*,*) '       real*8, intent(in) :: Q,Z,A     !(recoil energy, proton number Z and atom number A)'
    write(*,*) '       real*8, intent(in) :: mT,v      !(target mass and velocity) in the unit of [GeV,c]'
    write(*,*) '       real*8, intent(out) :: ans      ! dsigma/dQ in the unit of [GeV-3]'
    write(*,*) ''


  elseif (trim(WhatSubroutine).eq. 'Calc_dRdQ') then 

    write(*,*) ''
    write(*,*) '   LikeDM-DD/help: Calc_dRdQ(Detector_type,mx,sigsip,Q_,ans) ---> '
    write(*,*) ''
    write(*,*) '   A subroutine to calculate differential event rate dR/dQ. '
    write(*,*) ''
    write(*,*) '       real*8, intent(in) :: mx,sigsip ! DM mass, elastic cross section (pb)'
    write(*,*) '       real*8, intent(in) :: Q_        ! recoil energy in the unit of [GeV]'
    write(*,*) '       real*8, intent(out) :: ans      ! dR/dQ in the unit of [GeV-3]'
    write(*,*) ''

  elseif (trim(WhatSubroutine).eq. 'Predict_events') then 

    write(*,*) ''
    write(*,*) '   LikeDM-DD/help: Predict_events(What_experiment,mx,sigsip,ans) ---> '
    write(*,*) ''
    write(*,*) '   A subroutine to calculate the total evints per day per kg. '
    write(*,*) ''
    write(*,*) '     CHARACTER(LEN=*), intent(in) :: What_experiment'
    write(*,*) '       What_experiment = "PandaX-II", "LUX-2013", "LUX-2014-2016", or "XENON1T"'
    write(*,*) '     real*8, intent(in) :: mx,sigsip ! DM mass, spin-independent cross section (pb)'
    write(*,*) '     real*8, intent(out) :: ans      ! event rate in the unit of [day-1 kg-1]'
    write(*,*) ''


  elseif (trim(WhatSubroutine).eq. 'Read_DDLikeTable') then 

    write(*,*) ''
    write(*,*) '   LikeDM-DD/help: Read_DDLikeTable() ---> '
    write(*,*) ''
    write(*,*) '   A subroutine to load the likelihood tables (mx, R). '
    write(*,*) ''
    write(*,*) '   If users want to include their own likelihoods, '
    write(*,*) '   they shall modify this subroutine in order to read their table.'
    write(*,*) ''

  elseif (trim(WhatSubroutine).eq. 'DDexp_chisq') then 

    write(*,*) ''
    write(*,*) '   LikeDM-DD/help: DDexp_chisq(What_experiment,mx,R,chisq) ---> '
    write(*,*) ''
    write(*,*) '   A subroutine to calculate the test statistics, -2*ln(likelihood). '
    write(*,*) ''
    write(*,*) '     CHARACTER(LEN=*), intent(in) :: What_experiment'
    write(*,*) '       What_experiment = "PandaX-II", "LUX-2013", "LUX-2014-2016", or "XENON1T"'
    write(*,*) '     real*8, intent(in) :: mx,R      ! DM mass, event rate in the unit of [day-1 kg-1]'
    write(*,*) '     real*8, intent(out) :: chisq    ! -2*ln(likelihood)'
    write(*,*) ''

  elseif (trim(WhatSubroutine).eq. 'FindCL_range') then 

    write(*,*) ''
    write(*,*) '   LikeDM-DD/help: FindCL_range(n,x,chisqs,chisqCL,xCL) ---> '
    write(*,*) ''
    write(*,*) '   A subroutine to find out the x at the given the reference chisq. '
    write(*,*) ''
    write(*,*) '     integer, intent(in) :: n'
    write(*,*) '     real*8, intent(in) :: x(n),chisqs(n)'
    write(*,*) '     real*8, intent(in) :: chisqCL'
    write(*,*) '     real*8, intent(out) :: xCL(2) ! 1=lower, 2=higher limit'
    write(*,*) ''

  elseif (trim(WhatSubroutine).eq. 'Calc_dsigmadQ_EFT') then 
 
    write(*,*) ''
    write(*,*) '   LikeDM-DD/help: Calc_dsigmadQ_EFT(jx,mx,Z,A,v,Q,ans) ---> '
    write(*,*) ''
    write(*,*) '   A subroutine to calculate dsigma/dQ. '
    write(*,*) ''
    write(*,*) '     real*8, intent(in) :: jx   ! the DM spin'
    write(*,*) '     real*8, intent(in) :: mx   ! Dark Matter mass in the unit [GeV]'
    write(*,*) '     integer, intent(in) :: Z   ! Proton number of target'
    write(*,*) '     integer, intent(in) :: A   ! Atom number of target'
    write(*,*) '     real*8, intent(in) :: v    ! relative velocity in the unit of [c]'
    write(*,*) '     real*8, intent(in) :: Q    ! recoil energy in the unit of [GeV]'
    write(*,*) '     real*8, intent(out) :: ans ! dsigma/dQ in the unit of [GeV-3]'
    write(*,*) ''


  elseif (trim(WhatSubroutine).eq. 'Calc_total_transition_prob') then 

    write(*,*) ''
    write(*,*) '   LikeDM-DD/help: Calc_total_transition_prob(jx,mx,Z,A,v,Q,ans) ---> '
    write(*,*) ''
    write(*,*) '   A subroutine to calculate Transition Probability. Two arrays has to be given first. '
    write(*,*) '     DD__coep(15) is dimensionless value of coefficient of operator k for protons.'
    write(*,*) '     DD__coen(15) is dimensionless value of coefficient of operator k for neutrons.'
    write(*,*) '     The users can see Table-I @ 1708.04630.'
    write(*,*) '     If these two arrays is not given before call this subroutine, the Probability will be zero.'
    write(*,*) ''
    write(*,*) '     real*8, intent(in) :: jx   ! the DM spin'
    write(*,*) '     real*8, intent(in) :: mx   ! DM mass (GeV)'
    write(*,*) '     integer, intent(in) :: Z   ! Proton number of target'
    write(*,*) '     integer, intent(in) :: A   ! Atom number of target'
    write(*,*) '     real*8, intent(in) :: v    ! relative velocity in the unit of [c]' 
    write(*,*) '     real*8, intent(in) :: Q    ! recoil energy in the unit of [GeV]'
    write(*,*) '     real*8, intent(out) :: ans ! dsigma/dQ in the unit of [GeV-3]'

  elseif (trim(WhatSubroutine).eq. 'Calc_total_transition_prob_rel') then 

    write(*,*) ''
    write(*,*) '   LikeDM-DD/help: Calc_total_transition_prob_rel(jx,mx,Z,A,v,Q,ans) ---> '
    write(*,*) ''
    write(*,*) '   A subroutine to calculate relativistic Transition Probability. Two arrays has to be given first. '
    write(*,*) '     DD__dp(7) is dimensionless value of coefficient of operator k for protons.'
    write(*,*) '     DD__dn(7) is dimensionless value of coefficient of operator k for neutrons.'
    write(*,*) '     The users can see Eq. (15) @ 1708.04630.'
    write(*,*) '     If these two arrays is not given before call this subroutine, the Probability will be zero.'
    write(*,*) ''
    write(*,*) '     real*8, intent(in) :: jx   ! the DM spin'
    write(*,*) '     real*8, intent(in) :: mx   ! DM mass (GeV)'
    write(*,*) '     integer, intent(in) :: Z   ! Proton number of target'
    write(*,*) '     integer, intent(in) :: A   ! Atom number of target'
    write(*,*) '     real*8, intent(in) :: v    ! relative velocity in the unit of [c]' 
    write(*,*) '     real*8, intent(in) :: Q    ! recoil energy in the unit of [GeV]'
    write(*,*) '     real*8, intent(out) :: ans ! dsigma/dQ in the unit of [GeV-3]'

  elseif (trim(WhatSubroutine).eq. 'Calc_total_transition_prob_DirectDM') then 

    write(*,*) ''
    write(*,*) '   LikeDM-DD/help: Calc_total_transition_prob_DirectDM(jx,mx,Z,A,v,Q,ans) ---> '
    write(*,*) ''
    write(*,*) '   An example subroutine to calculate high-scale Transition Probability. Two arrays has to be given first. '
    write(*,*) '       real*8 DD__Q5(2)         ! coefficients of dimension-five operators using DirectDM code [GeV-1]'
    write(*,*) '       real*8 DD__Q6(4)         ! coefficients of dimension-six operators using DirectDM code [GeV-2]'
    write(*,*) '     The users can see Eq. (16&17) @ 1708.04630.'
    write(*,*) '     If these two arrays is not given before call this subroutine, the Probability will be zero.'
    write(*,*) ''
    write(*,*) '     real*8, intent(in) :: jx   ! the DM spin'
    write(*,*) '     real*8, intent(in) :: mx   ! DM mass (GeV)'
    write(*,*) '     integer, intent(in) :: Z   ! Proton number of target'
    write(*,*) '     integer, intent(in) :: A   ! Atom number of target'
    write(*,*) '     real*8, intent(in) :: v    ! relative velocity in the unit of [c]' 
    write(*,*) '     real*8, intent(in) :: Q    ! recoil energy in the unit of [GeV]'
    write(*,*) '     real*8, intent(out) :: ans ! dsigma/dQ in the unit of [GeV-3]'


  elseif (trim(WhatSubroutine).eq. 'Calc_dRdQ_EFT') then 

    write(*,*) ''
    write(*,*) '   LikeDM-DD/help: Calc_dRdQ_EFT(Detector_type,jx,mx,Q_,ans) ---> '
    write(*,*) ''
    write(*,*) '   A subroutine to calculate differential event rate dR/dQ. '
    write(*,*) ''
    write(*,*) '       Detector_type = "Xenon" only.'
    write(*,*) '       real*8, intent(in) :: jx   ! the DM spin'
    write(*,*) '       real*8, intent(in) :: mx   ! DM mass (GeV)'
    write(*,*) '       real*8, intent(in) :: Q_   ! recoil energy in the unit of [GeV]'
    write(*,*) '       real*8, intent(out) :: ans ! dR/dQ in the unit of [GeV-3]'
    write(*,*) ''

  elseif (trim(WhatSubroutine).eq. 'Predict_R_EFT') then 
   
    write(*,*) ''
    write(*,*) '   LikeDM-DD/help: Predict_R_EFT(What_experiment,jx,mx,ans) ---> '
    write(*,*) ''
    write(*,*) '   A subroutine to calculate the total evints per day per kg. '
    write(*,*) ''
    write(*,*) '     CHARACTER(LEN=*), intent(in) :: What_experiment'
    write(*,*) '       What_experiment = "PandaX-II", "LUX-2013", "LUX-2014-2016", or "XENON1T"'
    write(*,*) '       real*8, intent(in) :: jx   ! the DM spin'
    write(*,*) '       real*8, intent(in) :: mx   ! DM mass (GeV)'
    write(*,*) '       real*8, intent(in) :: Q_   ! recoil energy in the unit of [GeV]'
    write(*,*) '       real*8, intent(out) :: ans ! dR/dQ in the unit of [GeV-3]'
    write(*,*) ''   

  else
    write(*,*) 'The description subroutine ', trim(WhatSubroutine)
    write(*,*) 'is not implemented.'
  endif

  write(*,*) 'subroutine "LikeDM-DD-doc" finished. Exit LikeDM-DD.'
  stop
  return
end subroutine




 


















