! 
! Example of usage of LikeDM-DD 
! If users want to know how to call the subroutines, they can use "call LikeDM_DD_doc(WhatSubroutine)"   
! 
program main
 use DMFormFactor
 implicit none
 real*8 mx,sigsip,R,chisq
 real*8 spin

 call LikeDM_DD_doc('LikeDM-DD')

 mx=100d0
 sigsip=1d-8
 spin=0.5d0 

 ! example 1: Giving mx and sigsip to compute -2*ln(likelihood)
  call Predict_events('XENON1T',mx,sigsip,R)
  call DDexp_chisq('XENON1T',mx,R,chisq)
  write(*,*) 'example 1:',R,chisq

 ! example 2: non-Rel. operators, giving mx, DM spin, coupling to compute -2*ln(likelihood)
  DD__coep(:)=0d0
  DD__coen(:)=0d0
  DD__coep(1)=0.5d0
  DD__coen(1)=0d0
  call Predict_R_EFT('XENON1T',spin,mx,R)
  call DDexp_chisq('XENON1T',mx,R,chisq)
  write(*,*) 'example 2:',R,chisq

 ! example 3: Rel. operators, giving mx, DM spin, coupling to compute -2*ln(likelihood)
  DD__EFT_type=1
  DD__dp(:)=0d0
  DD__dn(:)=0d0 
  DD__dp(1)=1d0
  DD__dn(1)=1d0
  call Predict_R_EFT('XENON1T',spin,mx,R)
  call DDexp_chisq('XENON1T',mx,R,chisq)
  write(*,*) 'example 3:',R,chisq


 ! example 4: Rel. operators, giving mx, DM spin, coupling to compute -2*ln(likelihood)
  DD__EFT_type=2
  DD__Q5(:)=0d0         ! coefficients of dimension-five operators using DirectDM code [GeV-1]
  DD__Q6(:)=0d0         ! coefficients of dimension-six operators using DirectDM code [GeV-2]

  DD__Q6(1)=1d-10         
  call Predict_R_EFT('XENON1T',spin,mx,R)
  call DDexp_chisq('XENON1T',mx,R,chisq)
  write(*,*) 'example 4:',R,chisq



end program  
