#!/usr/bin/python
import sys,os
from numpy import *
import LikeDM



LikeDM.likedm_dd_doc('LikeDM-DD')
mx=100.0
sigsip=1e-8
spin=0.5

print ' You are using pyLikeDM-DD interface >>>\n'

# example 1: Giving mx and sigsip to compute -2*ln(likelihood)
R=LikeDM.directdet.predict_events('PandaXRun10',mx,sigsip)
chisq=LikeDM.directdetlike.ddexp_chisq('PandaXRun10',mx,R)
print 'example 1:',R,chisq

# example 2: non-Rel. operators, giving mx, DM spin, coupling to compute -2*ln(likelihood)
LikeDM.dmformfactor.dd__coep[:]=0.0
LikeDM.dmformfactor.dd__coen[:]=0.0
LikeDM.dmformfactor.dd__coep[0]=0.5
LikeDM.dmformfactor.dd__coen[0]=0.0
R=LikeDM.dmformfactor.predict_r_eft('PandaXRun10',spin,mx)
chisq=LikeDM.directdetlike.ddexp_chisq('PandaXRun10',mx,R)
print 'example 2:',R,chisq


# example 3: Rel. operators, giving mx, DM spin, coupling to compute -2*ln(likelihood)
'''
  LikeDM.dmformfactor.dd__eft_type ==1  if we want to consider interference between operators.
  LikeDM.dmformfactor.dd__eft_type ==2  if we want to use the relation from DirectDM code.
'''
LikeDM.dmformfactor.dd__eft_type=1  
LikeDM.dmformfactor.dd__dp[:]=0.0
LikeDM.dmformfactor.dd__dn[:]=0.0
LikeDM.dmformfactor.dd__dp[0]=1.0
LikeDM.dmformfactor.dd__dn[0]=1.0
R=LikeDM.dmformfactor.predict_r_eft('PandaXRun10',spin,mx)
chisq=LikeDM.directdetlike.ddexp_chisq('PandaXRun10',mx,R)
print 'example 3:',R,chisq


# example 4: Rel. operators using DirectDM result, coupling to compute -2*ln(likelihood)
LikeDM.dmformfactor.dd__eft_type=2  
LikeDM.dmformfactor.dd__q5[:]=0.0   # coefficients of dimension-five operators using DirectDM code [GeV-1]
LikeDM.dmformfactor.dd__q6[:]=0.0   # coefficients of dimension-six operators using DirectDM code [GeV-2]
LikeDM.dmformfactor.dd__q6[0]=1e-10
R=LikeDM.dmformfactor.predict_r_eft('PandaXRun10',spin,mx)
chisq=LikeDM.directdetlike.ddexp_chisq('PandaXRun10',mx,R)
print 'example 4:',R,chisq
       






 

